from gp2xtra import *
#from vidagr import *

VERSION = "1.0.0"

background_colour = 0, 0, 0
text_colour = 250, 250, 150
ver_colour = 120, 70, 170

def pressed_start(game): #exit
	game.running = 0 

def pressed_up(game): #tempo + 1
	game.tempo += 1

def pressed_down(game): #tempo - 1
	game.tempo -= 1

def pressed_left(game): #tempo - 10
	game.tempo -= 10

def pressed_right(game): #tempo + 10
	game.tempo += 10

def updatestats(game):
	game.background = loadImage_noAlpha("data/images/title.png")
	font = pygame.font.Font(None, 36)
	font_small = pygame.font.Font(None, 14)
	game.background.blit(font.render(str(game.tempo), 1, text_colour), (270, 200))
	game.background.blit(font_small.render(VERSION, 1, ver_colour), (5, 90))
	game.screen.blit(game.background, (0,0))
	pygame.display.flip()


class game_universe(gp2xtra_general):
  def __init__(self, screen = None):
	gp2xtra_general.__init__(self)
	self.screen = screen
	self.key_functions = {}  #key functions to check for
	self.keyNB_functions = {}  #key functions to check for (no bounce)

def handle_keys(game):
  UpdateKeys(game);
  for i in game.keyNB_functions.keys():
	if KeyPressedNoBounce(game, i, 4): 
		game.keyNB_functions[i](game)
		updatestats(game)
  for i in game.key_functions.keys():
	if KeyPressed(game, i): game.key_functions[i](game)


GNAME = "metro2x"
def main():
	sys.stderr.write("Welcome to "+GNAME+"\n")
	sys.stderr.write(VERSION+"\n")
	screen = gp2xtra_init()
	game = game_universe(screen)
	game.portable = gp2xtra_input_test()
	game.snd_tick = pygame.mixer.Sound("data/sound/clock.ogg")
	pygame_draw_rect = pygame.draw.rect
	game.tempo = 60 #bpm
	surface = pygame.Surface(size) 

#	surface.fill(background_colour) 
	updatestats(game)
	

	FRAME_RATE = 20
	ONEBEATPERMINUTE = 60 
	TIMERINC = ONEBEATPERMINUTE/FRAME_RATE

	game.keyNB_functions = {KEY_LEFT: pressed_left, KEY_RIGHT: pressed_right, KEY_UP: pressed_up, KEY_DOWN:pressed_down, KEY_START:pressed_start}

#	game.keyNB_functions = {KEY_A: pressed_text_a, KEY_B: pressed_text_b, KEY_X: pressed_text_x, KEY_L: pressed_text_l, KEY_R: pressed_text_r}

	#60 bpm means that one beat will occur every second
	timer = 0
	while game.running:
		clock.tick(FRAME_RATE) #cap framerate at x frames per second
#		if (timer % game.tempo) == 0:
		trigger = int((float(60)/float(game.tempo))*FRAME_RATE)
		if (timer % trigger) == 0:		
			game.snd_tick.play()
		timer += 1
		handle_keys(game)
#		pygame.display.flip()

if __name__ == '__main__': 
# import profile
# profile.run('main()')
 main()
